
\chapter{Analysis}

This chapter presents the Linux kernel, its development process, the coding style and the debugging tools. It also describes the high-level memory management in the kernel and also the individual functions and mechanism related to the mappings that must be understood before the patches can be explained. This whole chapter is based on kernel version \verb|v5.18|. Skilled kernel memory management developers can jump directly to \fullref{sec:design}.

%\section{OS in generals}
%\subsection{Unix}
%\subsection{Linux}
%\subsection{Windows}
%\subsection{MacOS}

\section{Linux}
Today's Linux distributions are open-source Unix-like operating systems consisting of the Linux kernel and supporting software libraries and packaging systems. The resulting product is therefore a combination. Although there are big software differences between individual distributions, all the main distributions use the same Linux kernel. Any change or upgrade to the kernel means an upgrade to all such distributions and can potentially have a huge impact.

\subsection{Linux kernel}
The kernel was initially released on 5th of October 1991 and nowadays is the fastest growing operating system in the world, supporting various devices including embedded, mobile, personal, servers and even supercomputers.

%\subsection{Open-source}
%Anyone can contribute
%License
%Authorship
%Cooperating/supporting businesses like SUSE, RedHat and others.

\subsection{Development process}

The most up to date public version of the Linux Kernel can be found in the git repository created by the Linux Foundation\footnote{Linux repository - \url{https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git/}}. If anyone wants to commit to the kernel, he/she has to make changes against some specific version as is described in the Documentation/process folder and especially in the submitting-patches.rst file located in the git repository itself. As a result, all changes in the kernel can be seen as individual commits, at least for several last years. This is very useful when trying to understand the changes because it is easy to find the corresponding changes in other parts of the kernel and usually a commit message explaining the idea behind it. Git itself was created by Linus basically for kernel development and is therefore embedded deeply in the development process.

\bigbreak

When the work is done, the commits are converted into patches and are then send as emails to the Linux mailing list\footnote{\cite{Richman}} and also directly to the people responsible for the part of the kernel changed. There is a tree system of maintainers and if the patch is to get merged into the mainline, it has to go through one branch from the bottom to top where Linus performs final check. When a given maintainer agrees with the patch, he/she just adds his sign-off signature to the email message/patch. All of the approved patches are then merged with the mainline to create a testing version. Apart from several test frameworks, most of the testing is done by just running the test version on as many devices as possible. It is made possible by quite a big community of kernel testers that voluntarily install and use this unstable version. This is mostly regression testing to ensure everything that worked before still works, stability is required much more than new features.

\bigbreak

All of the development communication is done by sending emails, which nowadays seems as a really obsolete development tool. At the first glance at thousand of emails daily with patches and other discussions about kernel, it really is overwhelming. If they were not well-formatted git patches that were being send around, most probably everyone would have gotten lost by now. The trick is also to use the right set of filters, spam blockers and if everyone follows the rules it just works. The fact the kernel is a functioning and widely used \gls{os} can serve as a proof.

\subsection{Tools used for development}
This is a list of tools that can be used for easier development.

\subsubsection{vim}
Vim is a modified version of vi, which stands for visual. It is a command line text editor and can edit all kinds of documents including source files in this case. It can be used as an editor to make simple changes, but vim can do much more than that. The editor is packed with commands that can be used to copy or move text, search patterns of text, replace text, traverse multiple files and most importantly create macros that are basically saved series of command that can do several simple tasks at once to achieve a complex change. When using several tabs with several files opened, you might want to consider using view command as a read-only variant of vim. Otherwise navigating to function definition might try to open a file for writing which is already opened for writing, which results in an error.

\subsubsection{grep}
Grep is a shell command used for finding patterns in its input, which is usually a file. This is probably the most useful tool to find definitions of functions, macros and variables. Additionally it can be used to find the correct function if you just guess part of the name or something that might appear in a comment nearby.

\subsubsection{git}
Git is a fast and distributed version management system. It is usually composed of upstream and local repositories. Local repositories are located at the development devices of individual contributors, upstream repository is usually located at a server either on premise or supplied by a third party. 
\bigbreak
A git repository consists of individual commits as small and compact change blocks and these commits together build up a graph with branches representing individual features. Branches are usually merged back into the mainline branch called master.
\bigbreak
Local repository is fully functioning copy and can use wide scheme of git commands. The history can be modified using rebase or cherry pick commands. This enables any user to achieve a clear and obvious step by step development history.
\bigbreak
Concurrent modifications can also create conflicts when trying to merge two versions together. This is usually problematic but with git, it can in many cases be fully automatic and even if manual resolving of conflicts is needed, it is often quite straight forward.
\bigbreak
Third party providers like GitHub or GitLab provide web frontends to manage the project and also offer many additional features that can enhance the development process like CI/CD.

\subsubsection{ctags}
This tool can process source files and create tags for individual elements like functions and properties. This allows for a quick search of definitions for function calls, which is used usually by client tools like vim (\verb|ctrl+]| to find definition and \verb|ctrl+t| to return). This upgrades vim to very useful source file viewer and dramatically decreases the time and effort needed to find definitions of helper functions used in the kernel. Unfortunately, it is not always accurate and sometimes fails to find the definition completely. Accuracy is problematic when multiple definitions for the same function are provided for different architectures or configurations. If the user does not pay attention, he might not realize the definition is valid only for the specific architecture. Another problem is with macros, where the localization of definitions sometimes fails completely and the only solution is using \gls{grep}.

\section{Running the kernel}
This section contains the whole process from getting the source files to building, running and debugging a modified kernel.

\subsection{Getting source files}
The most recent source files can be found in Linus's git repository\footnote{torvalds/linux git repository - \url{https://github.com/torvalds/linux/commits/master}}. However for normal uses the stable releases are ideal. This basically means to not use release candidates versions ending with the \verb|rc| suffix.

\subsection{Building}
Before building the source files, the kernel build has to be configured properly depending on your hardware and preferences, producing the \verb|.config| file. This can be quite hard for an inexperienced user but there are tools to do this automatically like genkernel for Gentoo. The generated configuration is not as optimized as if it was created by a skilled administrator, nonetheless the result is a functional configuration. The compilation itself can take some time, although on faster devices it should not be too long. Additionally, thanks to make, recompilation of partially modified kernel only recompiles the modified files.

\subsection{Running the kernel in a virtual machine}
When making changes to the kernel code and especially in the early phases, it is not a good idea to run the kernel on physical HW, as the code is most probably not completely flawless. Therefore it is best to run the kernel first virtually using \verb|qemu| or its wrapper \verb|virtme|. This will quickly reveal badly malfunctioning versions without threatening any real system. It is also quicker and overall more convenient to start a virtualized system. However, after the code seems to work more or less, it can be tested in a normal environment doing to get rid of the remaining bugs.

\subsection{Debugging the Kernel}
From my point of view, the documentation seems mostly incomplete or hidden very deep in the git commit messages. Some parts of code are quite well commented and understandable, but other are rather unintuitive. Most of the compact documentation on the internet is sometimes obsolete and sometimes it is hard to distinguish if it is obsolete or just incomplete. When you finally seem to understand what you need to do and you create a patch that builds and even solves the problem, you are left with debugging the side effects causing bug reports in kernel or other problems. Judging by my experience, it is usually very hard to pinpoint the source of the problem and create an appropriate fix. And when you do, you cannot be sure if it really helped, because replicating the problem is often not possible and you just have to wait if the problem reoccurs again or if it was truly resolved by the fix. One thing that can help is to add warnings or bug calls for any unexpected state of things, an overview can be seen in \tableref{tbl:warning_bugs}.

\bigbreak

\begin{table}
\centering
\begin{tabular}{|p{3.5cm}|p{10cm}|}
\hline
 Name & Description \\ \hline \hline

\verb|BUG| & Usually calls some special or invalid instruction. This interrupts the execution of the system call and the kernel is not responding properly to future requests, although the OS is not completely frozen. Specific behaviour depends on the architecture and the kernel version.\\ \hline
\verb|WARN| & Basically prints similar information as \verb|BUG| but does not interfere with execution. Although the same problem that triggered the warning might cause other problems in kernel.\\ \hline
\verb|BUG_ON| & Internally calls \verb|BUG|.\\ \hline
\verb|VM_WARN_ON| & Internally calls \verb|WARN_ON| if \verb|CONFIG_DEBUG_VM| is set.\\ \hline
\verb|VM_BUG_ON| & Internally calls \verb|BUG_ON| if \verb|CONFIG_DEBUG_VM| is set.\\ \hline
\verb|VM_BUG_ON_PAGE| & Dumps the given page and internally calls \verb|BUG| if \verb|CONFIG_DEBUG_VM| is set.\\ \hline
\verb|VM_BUG_ON_FOLIO| & Dumps the given folio and internally calls \verb|BUG| if \verb|CONFIG_DEBUG_VM| is set.\\ \hline
\verb|VM_BUG_ON_VMA| & Dumps the given VMA and internally calls \verb|BUG| if \verb|CONFIG_DEBUG_VM| is set.\\ \hline
\verb|VM_BUG_ON_MM| & Dumps the given memory descriptor and internally calls \verb|BUG| if \verb|CONFIG_DEBUG_VM| is set.\\ \hline
\end{tabular}
\caption{Overview of bugs and warnings calls.}
\label{tbl:warning_bugs}
\end{table}

When you want to run the modified kernel on a hardware device, you have to choose an appropriate Linux distribution that supports custom kernel versions. Usually it is possible for almost every distribution, however, some distributions make it very easy as Gentoo did for me.

\bigbreak

%Break points
%\gls{gdb}



\FloatBarrier

\subsection{Kernel coding style}

This subsection is abbreviated as all the important and usually up-to-date information is located directly in the Linux kernel's git repository.
According to \gls{gitlab}'s statistics, the kernel and related scripts in the repository are mostly written in C (~98.5\%), Assembler takes up about 1 \%, makefiles and other scripts take the rest. Coding style is more or less standard for C and is quite extensively described in the Documentation/process folder in the files coding-style.rst and 4.Coding.rst.
\bigbreak
The first and obvious difference against probably any modern code is the use of \gls{goto}s, which is not recommended in modern coding style. But their use in kernel is quite reasonable and prevents problems when changes are necessary. It is often used for clean up at the end of a function and because of some possible errors there might be several exit points. All of these can be directed to the right code at the end of the function via mentioned gotos. This saves unnecessary code duplication and ensures clean up is done thoroughly in all cases. There might be several labels for gotos to enable for gradual clean up depending on how deep in the function the thread gets before encountering an error. This is of course not the only use for gotos. A more complex application might be the context switch and other tricks in the deepest levels of the kernel.
%\bigbreak
%Assembler...possible extension
\bigbreak
The rest of the coding style is quite normal and can be easily found in the git repository as mentioned before. However, not all parts follow the standard as mostly the older code remains in the state as it was written years ago as there is no good reason to modify code just because of coding style.

%PageHead is implicitly defined using macros \_\_PAGEFLAG:
%        \_\_PAGEFLAG(Head, head, PF\_ANY) CLEARPAGEFLAG(Head, head, PF\_ANY)
%        (https://elixir.bootlin.com/linux/v5.0.5/source/include/linux/page-flags.h\#L517)

%\_\_PAGEFLAG defines TESTPAGEFLAG:
%        (https://elixir.bootlin.com/linux/v5.0.5/source/include/linux/page-flags.h\#L248)

%and TESTPAGEFLAG defines PageHead:
%        \#define TESTPAGEFLAG(uname, lname, policy) \
%        static \_\_always\_inline int Page\#\#uname(struct page \*page)
%        (https://elixir.bootlin.com/linux/v5.0.5/source/include/linux/page-flags.h\#L215)
        
       
%        source: https://www.spinics.net/lists/newbies/msg61376.html
        
        
%'git grep Foo\#\#' usually reveals the culprit. ;)

%source: https://www.spinics.net/lists/newbies/msg61378.html

\pagebreak

\section{Memory management in the Linux kernel}

The main role of the memory management is to distribute the available memory among the running processes and collect the unused memory, either indicated by a process or from a finished or a killed process.
\bigbreak
Today's devices usually have gigabytes of memory. Although in some cases, like embedded computers, the actual amount can be a lot lower. Memory is split into addressable units which are usually several bytes, e.g. 64-bit processors have natively 64-bit addressable units, although in some cases it might be possible to operate with smaller units like 32-bit.

\subsection{Virtual memory}
All of the memory resides in an address space, but because it would be impractical for all processes to use the same address space and it might cause interference between the processes, virtual address spaces are used. This means that every process has its own address space and individual addresses are translated by the CPU when they are accessed. This address space is called virtual address space and the memory is therefore called virtual memory.
\bigbreak
In the address space, the memory is divided into areas, which usually share some parameters like access rights and other flags, which depend on what is actually stored in the memory.

\subsection{Program memory anatomy}
As mentioned before, program's memory is virtualized and addresses are translated into their physical counterparts using page tables. 
\bigbreak
The address space of each process can be split into several main parts. These parts are the kernel space, the stack, the memory mappings including mapped files and mapped libraries, the heap and the uninitialized and initialized static variables and of course the binary image of the process's code.
\bigbreak
The individual memory mappings of a process can be examined by reading the \verb|/proc/$pid/maps| file and also \verb|/proc/$pid/smaps|, which is even more detailed. The \verb|$pid| can also be replaced with \verb|self| for some use cases.

\subsubsection{Kernel space}
The kernel space is used to store kernel's data and code and is part of the virtual address space, but it maps to the same physical memory in all processes. The kernel space is not directly accessible by a process, such an attempt will result in a page fault. Instead, a system call must be made to ask the kernel to do something for the calling process. This ensures that potentially malfunctioning or even insidious software will not be able to cause serious harm. On the other hand, user space, which contains all other parts of the address space, can be directly accessed by the process and usually changed as needed.

\subsubsection{Stack}
The stack is used to store local variables and function parameters. When a function call is made, all parameters (except for those passed directly in registers) are pushed to the stack and vice versa when the function returns. Stack is therefore dynamically growing and shrinking as needed. If many function calls are made, the stack might need to grow too large and exceed the maximum stack size. When this happens, the process is killed by the kernel. The limit ensures the stack will fit in the address space and not collide with any neighbouring memory segments. Each thread has its own stack and therefore even with plenty of available memory, multi-threaded applications might take up lots of address space.

\subsubsection{Memory mappings}
This is the part of process's memory where files can be mapped into virtual memory. This can be done using the \verb|mmap()| system call and is usually used to map extensively used file data. Dynamic libraries are also mapped in this way, and, for this thesis most importantly, anonymous memory mappings. The name itself is quite confusing, because it is not really a mapping but rather just a block of memory available for program's data.

\subsubsection{Heap}
The heap is used for runtime memory allocation that is not bound to function lifetime and can be used via pointer. Heap can be used to allocate bigger data segments like arrays and data can also be shared with other threads. Allocation is usually done via the \gls{malloc} call. Heap can be extended using the \gls{brk} system call if it runs out of space. After several cycles of allocating and freeing memory blocks, there might remain gaps which can be too small to use. This is called heap fragmentation and can be quite problematic in languages without garbage-collection.

\subsubsection{Static variables}
Static variable are divided into two segments. The first contains the uninitialized static variables, which are stored in an anonymous memory area. The second contains initialized static variables, which are stored in the binary file which is mapped using a private memory mapping, which ensures that potential changes are not reflected in the underlying file and static variables are initialized to values defined in the source code in the next run.

\subsubsection{Binary image}
The last is the binary image, which stores all the code and also string literals like error messages and so on. It is again private memory mapped binary file, which ensures immutability of the code.

\bigbreak

A more detailed explanation can be found in an article at\break \verb|manybutfinite.com|\footnote{\cite{Duarte}}.

%Possible extension → NULL address, what it is good for

\pagebreak
\section{Memory descriptor}
In Linux, every process is implemented as an instance of \verb|task_struct| structure. Memory itself is described in \verb|mm_struct|, which is accessible through the \verb|mm| field in the mentioned \verb|task_struct|. \verb|mm_struct| contains the start and end addresses of all the segments mentioned in the previous subsection as can be seen in \figureref{fig:mm_struct}, the number of physical memory pages of the process, the size of virtual address space \verb|total_vm| and other data.

\bigbreak


\begin{figure}
  \center
  \includegraphics[width=300px]{../img/mm_struct.png}
  \caption{Memory descriptor struct. Source: https://manybutfinite.com}
  \label{fig:mm_struct}
\end{figure}

\begin{figure}
  \center
  \includegraphics[width=300px]{../img/memory_descriptor_and_memory_areas.png}
  \caption{Memory descriptor and areas. Source: https://manybutfinite.com}
  \label{fig:mm_struct_areas}
\end{figure}


Most importantly \verb|mm_struct| contains a pointer to a list of virtual memory areas\break \verb|struct vm_area_struct *mmap| and pointer to page tables \verb|pgd_t *pgd|. Also important is the lock struct \verb|rw_semaphore mmap_lock|, which locks the whole structure during \verb|mmap()| or \verb|mremap()| calls.

\bigbreak

The stack grows down from \verb|start_stack| and so do memory mapped areas from \verb|mmap_base|. The heap grows up from \verb|start_brk| and has also an end pointer called \verb|brk|. The data segment is restricted by \verb|start_data| and \verb|end_data|, the code block is restricted by \verb|start_code| and \verb|end_code|, these segments do not grow in any direction, because they are immutable. Each of these areas is internally implemented as \verb|vm_area_struct| and can be traversed via \verb|vm_next| as can be seen in \figureref{fig:mm_struct_areas}, \verb|vm_area_struct| is in more detail explained in \fullref{sec:vma}.
				
%unsigned long (*get\_unmapped\_area) (struct file *filp,
%                                unsigned long addr, unsigned long len,
%                                unsigned long pgoff, unsigned long flags);

\bigbreak

A more detailed explanation of the memory descriptor and the source of figures is in \verb|How the kernel manages your memory|\footnote{\cite{Duarte2}}.

\pagebreak


\section{struct page}
This structure is a representation of a physical page, which usually has a size of 4096 bytes as it has been since the very first Linux kernel, and contains a number of various flags and other properties. The following two paragraphs describe only the two most important properties for this thesis, which are index and mapping. Useful functions operating with struct page can be viewed in \tableref{tbl:page_functions}

\bigbreak

The \verb|page→index| property stores an offset of this page within its mapping. Imagine we are mapping a second half of a file containing altogether 10 pages, then the indices of the pages will be 5, 6, 7, 8 and 9. If they all reside in a single \gls{vma} then the VMA's \verb|vm_pgoff| (page offset) will be the page offset of the first page that is 5. In the case of the anonymous mappings, that do not map any files, the page offset also exists and is e.g. used during \fullref{sec:rmap_walk} to pinpoint the correct VMA from the list of VMAs related to the AV of the page; the AV is accessible via \verb|page→mapping| explained next.

\bigbreak

The \verb|page→mapping| property can store a pointer to \verb|anon_vma| and also two flags\break (\verb|PAGE_MAPPING_ANON| and \verb|PAGE_MAPPING_MOVABLE|) in the lowest two bits.\break \verb|anon_vma| itself can be access through \verb|page_get_anon_vma()| function if it is assigned to the page. \verb|PAGE_MAPPING_ANON| is set if the page is anonymous and mapped into a user virtual memory area. \verb|PAGE_MAPPING_MOVABLE| is used during migration. A combination of the previous two bits is defined as\break \verb|PAGE_MAPPING_KSM|, which means the page is a \verb|KSM| shared page and in this case \verb|page→mapping| points to a private structure of the \verb|KSM|. The bits are defined in\break \verb|include/linux/page-flags.h|. In case of a page shared among several process through the \gls{cow} mechanism, the mapping property points to the root \verb|anon_vma|. 

\begin{table}
\centering
\begin{tabular}{|p{4.5cm}|p{9cm}|}
\hline
 Function/Constant & Description \\ \hline \hline

\verb|page_mapcount()| & The number of times given page is referenced by a page table.\\ \hline
\verb|page_swapcount()| & The number of references to the given page that are in swapped out state.\\ \hline
%\verb|page_trans_huge_mapcount| \verb|(struct page *page)| & returns highest mapcount any of the subpages has. This means that if return value is one then none of the subpages is shared.\\ \hline
%\verb|total_mapcount| \verb|(struct page *page)| & counts all virtual mappings of the subpages, where return value one means all the mappings belong to the same mm.\\ \hline
\verb|follow_page()| & The function used to locate and return a page based on its VMA and virtual address. It performs an operation similar to a page walk to get the correct \verb|PTE|. When working with the \verb|PTE|, it locks it using \verb|pte_offset_map_lock()| and also waits for possible page migration to end if the \verb|FOLL_MIGRATION| flag is set.\\ \hline
\verb|vm_normal_page()| & Simplified \verb|follow_page| that gets a direct pointer to the \verb|PTE| and therefore does not have to perform a page walk. Also omits some checks compared to \verb|follow_page()|. \\ \hline
\verb|PAGE_SHIFT| & Determines the page size and is used to shift the virtual address to remove page offset bits. It's value for standard 4096 ($2^{12}$) byte page is 12. \\ \hline
\end{tabular}

\caption{Overview of some page functions and a constant.}
\label{tbl:page_functions}
\end{table}

\FloatBarrier

\subsubsection{Compound page}
\label{sec:compound_page}
Compound page is a group of two or more physically contiguous pages that can in many aspects be treated as one large page. This is used to create transparent huge pages, but can be used for other purposes as well.
\bigbreak
The page flags are used to mark a compound page and distinguish between head and tail pages. This differs for 32-bit and 64-bit systems, but the functions \verb|PageCompound()|, \verb|PageHead()| and \verb|PageTail()| create a common interface.
\bigbreak
The page offset, which is normally saved in the \verb|page→index|, is saved in the\break \verb|page→index| of the head page. The tail pages can reuse the \verb|page→index| for other metadata like page order in case of \verb|page[1]| (second compound page). Functions \verb|thp_nr_pages()| or \verb|compound_nr()| for general compound pages can be used to get number of regular pages in the transparent huge/compound page. Compound pages are covered by a LWN article\footnote{\cite{Corbet1}}.

\subsubsection{Folio}
Folios are an abstraction level to cover pages and compound pages under a common interface. Otherwise when a function works with a page that is a part of a compound page, it might expect a head or a tail page. Page folios create a common interface for all functions that operate with normal or compound pages. The functions using folios are guaranteed that they will receive a normal page or a head page in the case of compound page and therefore do not have to check each time. This is quite a new concept\footnote{\cite{Corbet2}} and therefore there is still old code not fully using folios.

%\subsubsection{Page fault}
%\gls{todo}
%Page fault → page fault handling

%\href{https://unix.stackexchange.com/questions/382735/how-does-ptes-flags-are-restored-when-a-page-is-swapped-in-from-swap-area}{how-does-ptes-flags-are-restored-when-a-page-is-swapped-in-from-swap-area}

%entry = pte\_to\_swp\_entry(vmf→orig\_pte);
%lookup\_swap\_cache(entry, vma, vmf→address);

%int page\_swapcount(struct page *page)

%mm/memory.c → handle\_pte\_fault() and do\_swap\_page()

\subsection{Page tables, page translation}
Entries PGD, P4D, PUD, PMD and PTE are all parts of the virtual address and are levels of indirect addressing. Full names of the shortcuts follow.

\begin{itemize}

\item Page global directory (PGD)

\item Page level 4 directory (P4D)

\item Page upper directory (PUD)

\item Page middle directory (PMD)

\item Page table entry (PTE)

\end{itemize}


\subsubsection{Page middle directory (pmd)}
PMD level is important because migration waiting (see \fullref{sec:migration}) is done at this level and also  transparent huge pages take up a whole PMD range and can be accessed using the PMD entry.

\subsubsection{Page table entry (pte)}
\label{sec:pte}
PTE is the lowest level and each PTE entry represents a single page or a subpage of a compound page (see \fullref{sec:compound_page}). Page struct is obtainable using the \verb|vm_normal_page()| function. Not every PTE necessarily points to a page struct, as it is possible that the page is swapped out, as can be determined using \verb|is_swap_pte()| in which case the PTE can be converted to a \fullref{sec:swap_entry} using \verb|pte_to_swp_entry()| function. Another case when PTE does not point to a page is during migration. If a page is present or not can be determined by checking the PTE entry bits, which is done using the \verb|pte_present()| function. What bits precisely are checked depends on the architecture. Converting PTE to a page struct inside \verb|vm_normal_page()| function is done by shifting the PTE value and treating it as an index into the \verb|mem_map| array, where the page structures are stored\footnote{see Documentation/admin-guide/kdump/vmcoreinfo.rst → mem\_map}.
\bigbreak
Everything is pretty nicely described in Mel Gorman's book\footnote{\cite{Gorman}} and a more up to date LWN article\footnote{\cite{Corbet3}}.

\subsection{Pagewalk}
\label{sec:pagewalk}
The pagewalk mechanism walks page tables and applies user defined callbacks. There are multiple entry functions, with the main two being \verb|walk_page_range()|\break and \verb|walk_page_vma()|. The pagewalk goes recursively through all page table levels (from \verb|pgd| to \verb|pmd| and \verb|pte|). The walk is directed by the \verb|mm_walk| structure, which contains \verb|page_walk_action|, \verb|vm_area_struct|, \verb|mm_walk_ops| and other parameters. The \verb|mm_walk_ops| structure contains, among other things, entries for all page table levels and entries that are called before and after entering a VMA.

\subsubsection{walk→action}
An action is a mechanism that allows user-specific callbacks to instruct the pagewalk core on further actions. \verb|ACTION_CONTINUE| can be used to skip PTE action when PMD action is successful. This is useful when \verb|PMD| represents a transparent huge page and the desired operation is performed at this level and further action on \verb|PTE| does not make sense or would break something. \verb|ACTION_AGAIN| can be used to repeat certain action if previous attempt at the given page table level fails. The default setting is \verb|ACTION_SUBTREE|, which continues with actions on lower page table levels. 

%\subsubsection{walk\_hugepd\_range()}
%Walks through hugepd range, access individual ptes and call predefined pte\_entry operation.
\subsubsection{walk\_pte\_range\_inner()}
This function calls a predefined \verb|pte_entry| operation on each PTE in a for-cycle.
\subsubsection{walk\_pte\_range()}
This function calls \verb|pte_offset_map_lock()| or \verb|pte_offset_map()| to protect the whole PMD. Walks through PTEs by calling \verb|walk_pte_range_inner()|. 
\subsubsection{walk\_pmd\_range()}
This function walks through the PUD range, goes through an array of PMDs and calls \verb|walk_pte_range()| for each. If the PMD holds a \verb|hugepd|, then\break \verb|walk_hugepd_range()| is called.
%\subsubsection{walk\_pud\_range()}
%Walks through pud range and call walk\_pmd\_range(). If this pud holds a hugepd, then walk\_hugepd\_range() is called.
%\subsubsection{walk\_p4d\_range()}
%Walks through p4d range and call walk\_pud\_range(). If this p4d holds a hugepd, then walk\_hugepd\_range() is called.
%\subsubsection{walk\_pgd\_range()}
%Walks through pgd range and call walk\_p4d\_range(). If this pgd holds a hugepd, then walk\_hugepd\_range() is called.
%\subsubsection{walk\_hugetlb\_range()}
%Call predefined hugetlb\_entry operation on each pte.
%\subsubsection{\_\_walk\_page\_range}
%If vma has VM\_HUGETLB flag set than we call walk\_hugetlb\_range() otherwise we call walk\_pgd\_range().

\subsection{Forking and Copy-on-write}
When forking a process, fork will not create copies of all the necessary data immediately, but the two processes (parent and child) will share some pages as long as they do not write to them. When the page is to be written for the first time after the fork, then the page is first copied and only afterwards modified. This saves memory that would otherwise be wasted for duplicate copies and also saves some operation time that would be consumed for the copying itself at that time. This is especially important when the first thing the new process does is calling exec to load a new program, which would make all the copying completely useless. More details can be found in an article at Halolinux.us\footnote{\cite{Frazier}}
\bigbreak
During \verb|mremap()| or \verb|vma_merge()| \verb|mmap_lock| is locked and therefore forking cannot interfere with either of the mechanisms.
%How does forking work in context of \verb|anon_vma|\_chain and related VMA and \verb|anon_vma| supporting structures...

\subsection{Kernel samepage merging}
\label{sec:ksm}

KSM is a de-duplication mechanism that can merge private anonymous pages with identical content. The KSM daemon periodically scans areas of memory specified by a \verb|madvise| call and if duplicates are found, they are replaced by a single write-protected page. If the page is modified later then it is automatically copied before the modification itself. This mechanism is mainly used in virtualization to prevent duplication between individual instances but can be used anywhere. It can be quite demanding though in terms of processing power, so it should be used with care. To activate the daemon, value \verb|1| has to be saved into the \verb|/sys/kernel/mm/ksm/run| file. Also other important parameters must be set in order for the daemon to work properly, these are \verb|pages_to_scan| and \verb|sleep_millisecs| located in the same folder. The \verb|pages_to_scan| parameter specifies how many pages should be scanned, low value can dramatically increase the time needed for the daemon to find duplicates, the same goes for \verb|sleep_millisecs|, which prolongs waiting time.

More details about KSM can be found in the kernel documentation\footnote{see "Documentation/admin-guide/mm/ksm.rst"} in the git repository.

\subsection{Swap}
Swapping is the process of removing pages from memory and storing them to a long-term storage device. This is usually done to acquire free memory that is needed for other purposes. A more precise term for swap is page out, which is also sometimes used in the kernel. For the purposes of this work, it is necessary to be aware of swapping as it means some pages might not be present in memory when merge is attempted and such a situation is reflected in the state of the concerned kernel structures, most importantly the swap entry.

\subsubsection{Swap entry}
\label{sec:swap_entry}
Normally, when a page is mapped into virtual memory, there is a PTE pointing to this page. However, when the page is not mapped, the PTE internally holds an instance of a swap entry. The swap entry can be converted into the \verb|swap_info_struct| to get the number of processes referencing it either as mapped or as unmapped (swapped out).

\subsubsection{Swap map}
The \verb|swap_info_struct| structure has a variable called \verb|swap_map|, which is an array of reference counts of the swapped page. Each cell can hold the maximum value of \verb|SWAP_MAP_MAX|, which is \verb|0x3e|. If the reference count gets higher, a special mechanism using continuation pages is used to extend the maximum possible value. Continuation pages can be allocated several times to support very high reference counts that can be caused by e.g. swapped out \gls{ksm} pages.

\subsubsection{Swap cache mechanism}
\label{sec:swap_cache}
This mechanism ensures consistency between memory and swap space when a shared mapping is created among several processes and one of the pages is being swapped out. This can happen even for a private mapping as it can be shared using the \gls{cow} mechanism after a fork call.
\bigbreak
When attempting to swap out a page, the page is first added to the swap cache and then an attempt is made to unmap it for all the processes using it. The\break \fullref{sec:rmap_walk} is used for this purpose and it is done by converting the appropriate PTEs to instances of a swap entry. 
\bigbreak
Until this is done, the swap cache is being used to ensure consistency. This is necessary as the whole process can take some time and in the meantime one of the other processes might try to write to the page. The swap cache ensures that such a write is successfully written to the backing storage.
\bigbreak
If the unmap fails for even one process, the whole swapping attempt is cancelled as it would not make any sense because the page has to remain in memory as long as even a single process has it mapped.
\bigbreak
Another use for the swap cache is in the reversed situation, when a shared page is swapped out and one process accesses it. In this case the page is swapped back in and the PTE of the faulting process is marked as present. However, the other processes do not get notified and still see this page as swapped out and the swap cache again ensures that possible changes in memory from one process are not overwritten by an outdated version in the backing storage.
\bigbreak
More details are available in Mel Gorman's book\footnote{\cite{Gorman2}}



%the page Even PRIVATE and anonymous mapping are added to the swap cache, but in the shrink\_page\_list() there is an attempt using function try\_to\_unmap() to unmap the page from all the other processes mapping it. These process are located using rmap\_walk(). This is successful for the private mapping and therefore swap cache is very short-lived in case of private mappings.

%add\_to\_swap() → add\_to\_swap\_cache()

%\_\_read\_swap\_cache\_async() → add\_to\_swap\_cache()

%\subsubsection{Page fault from swap for COW}
%\gls{todo}
%do\_swap\_page() → with exclusive set to 0. Goes to do\_page\_add\_anon\_rmap()

\subsubsection{kswapd()}

The \verb|kswapd()| function is responsible for swapping when running out of memory or already out of memory. \verb|kswapd()| is started as a kernel thread at the boot and continuously monitors memory. The \verb|pageout()| function actually performs the action but kernel first jumps through a series of other functions doing the necessary preparations.
%kswapd() → balance\_pgdat() → kswapd\_shrink\_node() → shrink\_node() → shrink\_node\_memcgs() → shrink\_lruvec() → shrink\_list() → shrink\_inactive\_list() → shrink\_page\_list() → pageout()


\subsection{Migration}
\label{sec:migration}

The migration mechanism can be used to move physical pages between memory of separate NUMA nodes or during memory compaction\footnote{\cite{Zhang}}. If the page is being moved then all PTEs mapping the page are set to a migration entry that signals the operation is in progress. The underlying page struct cannot be accessed at such time.

\pagebreak

\section{Virtual memory area}
\label{sec:vma}
The virtual memory area or shortly \gls{vma} is at the center of memory management in kernel and also this thesis. As the name states it describes a memory area as a part of the virtual memory of a process. Sometimes VMA is referred to as a mapping. Each VMA has a start and an end address, a file pointer and also a page offset, referring to an offset in a file in number of memory pages. Other attributes include protection rights, a pointer to an address space, the embedded node of a red black tree containing other VMAs, a number of flags and most importantly a pointer to its \verb|anon_vma| and a linked list of \verb|anon_vma_chain| structures as described in the following section \fullref{sec:anon_vma}.

\subsection{Flags}
When creating a virtual memory area a number of \verb|mmap()| call flags can be used. The individual flags are described in the \verb|mmap()| manual page, but I will mention some of them here as well. The most important one for us is \verb|MAP_ANONYMOUS|, which creates a mapping that is not backed by a file and basically provides a chunk of memory to the caller. An anonymous mapping can be used in combination with \verb|MAP_PRIVATE| to create a private mapping not shared with other processes. On the contrary \verb|MAP_SHARED| creates a mapping shared among several processes and can be used to share data, communicate etc. Another useful flag is \verb|MAP_FIXED|, which enforces the use of the specified address parameter, that is normally only taken as a hint, any existing mapping standing in the way is discarded. More details about various flags are described in the \verb|mmap()| syscall manual page. Each mapping also has an attribute called \verb|vm_flags| which holds similar flags, but not quite identical. All \verb|vm_flags| flags are defined and described in \verb|include/linux/mm.h|. Conversion between the two sets of flags is defined by the \verb|mmap()| implementation.


\section{Anonymous virtual memory area aka AV}
\label{sec:anon_vma}
The \verb|anon_vma| heads a list of private "related" VMAs. These VMAs are related because they usually originated from a single VMA either by forking or splitting. When \verb|mmap()| is called on a range adjacent to an already existing VMA then the \verb|anon_vma| of the already existing VMA can be reused when the new mapping is faulted to enable future merge when both VMAs share flags and other parameters.
\bigbreak
The AV structure is important because VMAs come and go as they are split and merged in \verb|mprotect()|, \verb|mremap()| and other system calls. The \verb|anon_vma| serves as a relatively stable structure that anonymous pages can point to and \verb|anon_vma| then points to a list of the VMAs. For example when we want to swap out a page, we need to unmap it from all the VMAs mapping it. Which is easily and efficiently done using the pointer to the AV and then by going through its VMAs.
\bigbreak
The list (internally a red black tree) of VMAs can be traversed through the \verb|rb_root| variable. More details follow.

\subsection{Structure anon\_vma\_chain}
\label{sec:anon_vma_chain}
Copy on write can cause an \verb|anon_vma| to become associated with several processes and therefore even several VMAs. Furthermore each child VMA must have its own \verb|anon_vma|. When child process writes to a page then the page is copied (by COW) and the copy is assigned to child's own \verb|anon_vma|. This means that the relation goes both ways, each VMA can be related to several \verb|anon_vma| and each \verb|anon_vma| can be related to several VMAs. This is where AVC (\verb|anon_vma_chain|) comes in.
\bigbreak
In \figureref{fig:avc_overview} we can see a simple example consisting of two VMAs sharing a common AV, e.g. as a result of a fork. The top line belongs to the parent process and the other items belong to the child. The child VMA also has its own AV. Generally speaking each AVC points to its VMA and to its \verb|anon_vma| (black links). Each VMA can have several AVCs that are linked together through a linked list (red links) starting in \verb|anon_vma_chain| variable in a VMA struct. On the other hand each AV can also have several AVCs that are organized in a red black tree (blue links) with root stored in \verb|rb_root| variable in the AV structure.

\begin{figure}
  \includegraphics[width=\linewidth]{../img/anon_vma_chain_overview_labeled.png}
  \caption{AVC overview.}
  \label{fig:avc_overview}
\end{figure}

\bigbreak
Quite good, although slightly outdated, article about anonymous VMAs and their relations called \verb|The case of the overly anonymous anon_vma|\footnote{\cite{Corbet4}} can be found at lwn.net.


\section{The mmap() function}

\verb|void *mmap(void *addr,|\break
\indent\indent\indent\indent\verb| size_t length,|\break
\indent\indent\indent\indent\verb| int prot,|\break
\indent\indent\indent\indent\verb| int flags,|\break
\indent\indent\indent\indent\verb| int fd,|\break
\indent\indent\indent\indent\verb| off_t offset)|\break

This is the central syscall of the whole work. As the manual page says the \verb|mmap()| call can be used to map files or devices into memory, but apart from that it can also created mapping which do not map any files and are basically just an allocation of memory or rather the first step in the process. These special mappings are called anonymous and are created using the appropriate flag argument called \verb|MAP_ANONYMOUS|. 
\bigbreak
For the purposes of this thesis we will not deal with the file or device mappings directly, but sometimes we will come across them, so it is important to keep their existence in mind.
\bigbreak
\verb|mmap()| only creates the \gls{vma} but does not allocate anything. This a lazy approach betting on the possibility that the memory might not be used or maybe not fully at this time. Also allocating big amounts of memory instantly might seem slow and it can be better to allocate the memory over a period of time as needed. This is closely connected to \verb|anon_vma| allocation, which is not created during the \verb|mmap()| call, but later after the first page fault. A fault can either allocate a new \verb|anon_vma| or it can reuse one already being used by a neighbouring VMA, if it has identical vma policies and other flags. This is checked by \verb|find_mergeable_anon_vma()| function, which is called through series of functions from \verb|handle_pte_fault()|. Reuse is important, because areas with different \verb|anon_vma|s can never merge as merging of two VMAs with different \verb|anon_vma|s is not allowed.
\bigbreak
The actual properties of the created mapping can be specified by the call parameters, which include the desired address and length, the protection setting, the file descriptor and the offset in the file. For this thesis, file mappings will be just marginal topic as it mostly concentrates on anonymous mappings.
\bigbreak
Even though page offset originally meant offset inside of the mapped file, the anonymous mappings use it as well. However the value is set as a page offset from zero address and is therefore calculated as \verb|address >> PAGE_SHIFT|. This is very important when it comes to merging later as page offset is one of the parameters compared before a successful merge.

\pagebreak
\section{The vma\_adjust() function}
\label{sec:vma_adjust}

\verb|int __vma_adjust(struct vm_area_struct *vma,|\break
\indent\indent\indent\indent\indent\indent \verb|unsigned long start,|\break 
\indent\indent\indent\indent\indent\indent \verb|unsigned long end, pgoff_t pgoff,|\break
\indent\indent\indent\indent\indent\indent \verb|struct vm_area_struct *insert,|\break
\indent\indent\indent\indent\indent\indent \verb|struct vm_area_struct *expand)|\break


This function rearranges VMAs locally, effectively performing a merge, or reassigns part of one VMA to another. The \verb|vma_adjust()| function is just a wrapper for \verb|__vma_adjust()|, which contains the implementation. All the parameters are more or less self-explanatory except for \verb|insert|, which holds a new VMA that is to be inserted into the VMA interval tree and other structures when the \verb|vma_adjust()| call is a result of a split operation. Other less understandable parameter is \verb|expand|, which marks which VMA should be expanded when merging two or three VMAs together.
\bigbreak
For the purposes of this section I will use the variable names from the code. First, the parameters \verb|start| and \verb|end| are compared with the \verb|next| VMA to determine the intersection and set the appropriate \verb|remove_next| and \verb|adjust_next| variables, which are later applied. There is also the \verb|importer-exporter| mechanism, which ensures that when moving pages between two VMAs, where the receiving VMA does not have an \verb|anon_vma| assigned to it, then the providing VMA's \verb|anon_vma| is used.
\bigbreak
When preparations are ready, the actual adjusting is to be done. This consists of basically 2 parts. The first part is locking and unlocking of appropriate locks and adjusting boundaries and other parameters. The second part is removing the obsolete merged structures and cleaning up, the more sensitive part of the clean up is done before releasing the locks. When the \verb|vma| is to be merged with not one but two following VMAs, which is indicated by \verb|remove_next| value, then the adjusting is repeated twice, once for each of the merged VMAs. This is necessary because the presented code is capable of merging only two VMAs at once and therefore the merge is basically done twice.

\pagebreak
\section{The vma\_merge() function}
\label{sec:vmamerge}

\verb|struct vm_area_struct *vma_merge(|\break
\indent\indent\indent\indent\indent\indent \verb|struct mm_struct *mm,|\break
\indent\indent\indent\indent\indent\indent \verb|struct vm_area_struct *prev,|\break
\indent\indent\indent\indent\indent\indent \verb|unsigned long addr,|\break
\indent\indent\indent\indent\indent\indent \verb|unsigned long end,|\break
\indent\indent\indent\indent\indent\indent \verb|unsigned long vm_flags,|\break
\indent\indent\indent\indent\indent\indent \verb|struct anon_vma *anon_vma,|\break
\indent\indent\indent\indent\indent\indent \verb|struct file *file,|\break
\indent\indent\indent\indent\indent\indent \verb|pgoff_t pgoff,|\break
\indent\indent\indent\indent\indent\indent \verb|struct mempolicy *policy,|\break
\indent\indent\indent\indent\indent\indent \verb|struct vm_userfaultfd_ctx vm_userfaultfd_ctx,|\break
\indent\indent\indent\indent\indent\indent \verb|struct anon_vma_name *anon_name)|\break

Function \verb|vma_merge()| is used for attempted merging of \gls{vma}s. This function is called when a new VMA is created or when an already existing VMA is moved, resized or otherwise modified and there is a chance it might be merged with another VMA. Possible candidates are the previous and the following VMA. If the VMA in question neatly fills the hole between the two VMAs, all three of them might be merged together.

\bigbreak

A number of conditions have to be fulfilled before the merge itself can be executed. First, the VMAs have to be adjacent, this in case of the previous VMA means that \verb|prev→vm_end == addr| and for next VMA it means\break \verb|next→vm_start == end|. Apart from this, both VMAs also have to be compatible in regard of their policies and also other flags and parameters including page offsets. This is checked in two special functions (\fullref{sec:can_vma_merge_before} and \fullref{sec:can_vma_merge_after}), which depend on whether the VMA being merged is before or after the VMA we are merging to.

\bigbreak

A big issue preventing merging of VMAs is impossibility to merge two VMAs linked to two different \gls{av}s. This is because it is problematic to change to which AV a particular VMA is linked to. Every physical page, respectively every struct page representing it, has a pointer to its AV and so each physical page may be linked to only one AV. But the page might be used by several processes and therefore several VMAs. Each VMA has only one main AV, but can have several other AVs connected via AVCs. These other AVs are the result of a \gls{cow} operation where VMA inherits AVs of its parent. One of the AVs has to be the same as is stored in the physical pages of the VMA in question. Assigning the physical pages to a different VMA (as a result of the merge) would imply adding new AV to the merged VMA. This would enlarge the AVCs and slow down their traversal, but most importantly it would break the invariant that additional AVs are inherited from ancestors. 
\break
Another option is to instead change the AV of the physical pages. This would be impossible if another VMA with a different AV were using it too. When the other VMA is linked to the same AV, we might change the AV for both of them, but finding all concerned VMAs might take some time and gets complicated.

\bigbreak

On the other hand there are simple cases in which none of the above mentioned problems occur and they might be merged, however, in the current kernel two VMAs linked to two different AVs cannot be merged no matter what.


\subsection{The is\_mergeable\_vma() function}

\verb|static inline int is_mergeable_vma(|\break
\indent\indent\indent\indent\indent\indent \verb|struct vm_area_struct *vma,|\break
\indent\indent\indent\indent\indent\indent \verb|struct file *file,|\break
\indent\indent\indent\indent\indent\indent \verb|unsigned long vm_flags|\break
\indent\indent\indent\indent\indent\indent \verb|struct vm_userfaultfd_ctx vm_userfaultfd_ctx,|\break
\indent\indent\indent\indent\indent\indent \verb|struct anon_vma_name *anon_name)|\break
                                
Compares a given VMA A and given VMA flags and other parameters that describe VMA B. The check determines if these two VMAs can be merged together. VMA B is represented only by its parameters because in some cases it does not yet exist.

\subsection{The is\_mergeable\_anon\_vma() function}
\verb|static inline int is_mergeable_anon_vma(|\break
\indent\indent\indent \verb|struct anon_vma *anon_vma1,|\break
\indent\indent\indent  \verb|struct anon_vma *anon_vma2,|\break
\indent\indent\indent  \verb|struct vm_area_struct *vma)|\break


When trying to merge an already existing VMA A and a possibly not-yet-existing VMA B, this function compares their \gls{av}s, which have to be the same. An exception is when at least one of the AVs does not exist (meaning that its VMA is not yet faulted) and at the same time VMA A does not exist or VMA A references only a single AV.

\subsubsection{Function can\_vma\_merge\_before()}
\label{sec:can_vma_merge_before}

\verb|static int can_vma_merge_before(|\break
\indent\indent\indent \verb|struct vm_area_struct *vma,|\break
\indent\indent\indent \verb|unsigned long vm_flags,|\break
\indent\indent\indent \verb|struct anon_vma *anon_vma,|\break
\indent\indent\indent \verb|struct file *file,|\break
\indent\indent\indent \verb|pgoff_t vm_pgoff,|\break
\indent\indent\indent \verb|struct vm_userfaultfd_ctx vm_userfaultfd_ctx,|\break
\indent\indent\indent \verb|struct anon_vma_name *anon_name)|\break

This function receives a list of parameters representing VMA B that might not yet exist and also an already existing VMA A that B should be merged to. In this \verb|before| case B is or will be lying before A. This function internally calls functions \verb|is_mergeable_vma()| and \verb|is_mergeable_anon_vma()|, described above, and additionally checks if the page offsets are compatible.
\subsubsection{Function can\_vma\_merge\_after()}
\label{sec:can_vma_merge_after}
\verb|static int can_vma_merge_after(|\break
\indent\indent\indent \verb|struct vm_area_struct *vma,|\break
\indent\indent\indent \verb|unsigned long vm_flags,|\break
\indent\indent\indent \verb|struct anon_vma *anon_vma,|\break
\indent\indent\indent \verb|struct file *file,|\break
\indent\indent\indent \verb|pgoff_t vm_pgoff,|\break
\indent\indent\indent \verb|struct vm_userfaultfd_ctx vm_userfaultfd_ctx,|\break
\indent\indent\indent \verb|struct anon_vma_name *anon_name)|\break

Same as \verb|can_vma_merge_before()| with the difference of VMA B being \verb|after| VMA A.


\pagebreak
\section{The mremap() function}

\verb|void *mremap(void *old_address,|\break
\indent\indent\indent\indent\indent  \verb|size_t old_size,|\break
\indent\indent\indent\indent\indent  \verb|size_t new_size,|\break
\indent\indent\indent\indent\indent  \verb|int flags,|\break
\indent\indent\indent\indent\indent  \verb| ... /* void *new_address */)|\break

The \verb|mremap()| syscall is used to remap a memory mapping, which means to shrink or expand it and potentially also move it at the same time. The \verb|mremap()| call takes up to five arguments, which correspond to what task \verb|mremap()| is supposed to perform. They are the old size and the old address, the new size and potentially also the new address. The last argument is an integer representing flags, they are only three compared to dozens of flags in the case of the \verb|mmap()| syscall.
\bigbreak
The new address can be either specified in combination with the\break \verb|MREMAP_FIXED| flag, or, if not, the kernel will find a suitable new address on its own when moving is necessary and \verb|MREMAP_MAYMOVE| is set to allow moving. When moving is not allowed but is necessary, because expansion in place is not possible, \verb|mremap()| will fail and return an error value. 
\bigbreak
\verb|mremap()| can be an opportunity for a merge, because in many cases the new location might be adjacent to a compatible mapping. However, in the current kernel, the merge never happens for anonymous mappings, because the page offset is not updated in \verb|mremap()| and prevents the merge. On the other hand, for file mappings, this works when the mappings map the same file and are adjacent.

\subsubsection{Code structure}
As it was mentioned above, \verb|mremap()| can do several things defined by the flags and other parameters and also by the circumstances of the chosen location. 
\bigbreak
The first thing done is evaluation of flags in combination with other parameters to die quickly in case of incompatible combinations. In such cases, \verb|-EINVAL| is returned. Next, the VMA at the given address is found and if no such VMA exists, \verb|EFAULT| is returned.
\bigbreak
Now there are several cases of what needs to be done. In case of flags \verb|MREMAP_FIXED| or \verb|MREMAP_DONTUNMAP|, VMA will be moved either because the caller wanted it or because we have to preserve an old mapping. This is done in the \verb|mremap_to()| function, described in the next subsection. If that is not the case it might be possible to shrink or expand the mapping in place. The shrinking is easy and it just means to unmap the range between the old and the new end address. The expansion is more complicated because it might interfere with the next VMA. If old length is exactly to the end of the area then it is possible to just expand the mapping when it will not intersect with the next area. On the other hand if the old length is not to the end or expansion would intersect with another area, it is necessary to find a suitable unmapped area using \verb|get_unmapped_area()| and move the VMA to the new location, which is done using the \verb|move_vma()| function.

\subsection{The mremap\_to() function}

\verb|static unsigned long mremap_to(|\break
\indent\indent\indent\indent\indent  \verb|unsigned long addr,|\break
\indent\indent\indent\indent\indent  \verb|unsigned long old_len,|\break
\indent\indent\indent\indent\indent  \verb|unsigned long new_addr,|\break
\indent\indent\indent\indent\indent  \verb|unsigned long new_len,|\break
\indent\indent\indent\indent\indent  \verb|bool *locked,|\break
\indent\indent\indent\indent\indent  \verb|unsigned long flags,|\break
\indent\indent\indent\indent\indent  \verb|struct vm_userfaultfd_ctx *uf,|\break
\indent\indent\indent\indent\indent  \verb|struct list_head *uf_unmap_early,|\break
\indent\indent\indent\indent\indent  \verb|struct list_head *uf_unmap)|\break

This function moves the VMA mapping to a new location and optionally shrinks or expands it. This happens in \verb|mremap()|, if the new location is either enforced by \verb|MREMAP_FIXED| flag or, if the old mapping should not be unmapped, in case of \verb|MREMAP_DONTUNMAP| flag. Basically, it just calls \verb|move_vma()|, but it does a number of checks and preparations first. It unmaps the already-existing mappings in the target location and also exceeding part of the source mapping if the VMA is being not only moved but also shrinked, the rest of the source mapping is unmapped in the \verb|move_vma()| as part of the move process (this is of course omitted if \verb|MREMAP_DONTUNMAP| is set). If the new location is not fixed, the new location is chosen as the first suitable location found by \verb|get_unmapped_area()| call.

\subsection{The get\_unmapped\_area() function}

\verb|get_unmapped_area(struct file *filp,|\break
\indent\indent\indent\indent\indent  \verb|unsigned long addr,|\break
\indent\indent\indent\indent\indent  \verb|unsigned long len,|\break
\indent\indent\indent\indent\indent  \verb|unsigned long pgoff,|\break
\indent\indent\indent\indent\indent  \verb|unsigned long flags)|\break

Finds an unmapped area of the required length either at the specified location, if it is unmapped or flag \verb|MAP_FIXED| is set, or anywhere where there is enough space.

\subsection{The move\_vma() function}

\verb|static unsigned long move_vma(|\break
\indent\indent\indent\indent\indent  \verb|struct vm_area_struct *vma,|\break
\indent\indent\indent\indent\indent  \verb|unsigned long old_addr,|\break
\indent\indent\indent\indent\indent  \verb|unsigned long old_len,|\break
\indent\indent\indent\indent\indent  \verb|unsigned long new_len,|\break
\indent\indent\indent\indent\indent  \verb|unsigned long new_addr,|\break
\indent\indent\indent\indent\indent  \verb|bool *locked,|\break
\indent\indent\indent\indent\indent  \verb|unsigned long flags,|\break
\indent\indent\indent\indent\indent  \verb|struct vm_userfaultfd_ctx *uf,|\break
\indent\indent\indent\indent\indent  \verb|struct list_head *uf_unmap)|\break

This function takes a VMA pointer, the old and the new addresses and the length, and moves the given VMA to the new specified location. It assumes the new location is already prepared and there is no mapping there. This is solved by the caller either by unmapping the old mapping or by finding a suitable unmapped area. Internally, the move is done by calling \verb|copy_vma()|, which creates a copy in the new location (it might possibly be merged to its neighbours). Either way, the next step is to move the page table entries from the old to the new VMA, which is handled by \verb|move_page_tables()|, it might happen that this fails and in that case \verb|move_page_tables()| is called again in the opposite direction.

\subsection{The copy\_vma() function}

\verb|struct vm_area_struct *copy_vma(|\break
\indent\indent\indent\indent\indent  \verb|struct vm_area_struct **vmap,|\break
\indent\indent\indent\indent\indent  \verb|unsigned long addr,|\break
\indent\indent\indent\indent\indent  \verb|unsigned long len,|\break
\indent\indent\indent\indent\indent  \verb|pgoff_t pgoff,|\break
\indent\indent\indent\indent\indent  \verb|bool *need_rmap_locks,|\break
\indent\indent\indent\indent\indent  \verb|bool *update_pgoff)|\break

Creates a copy of a VMA in the specified location defined by the address, the length and the page offset. Other arguments needed are taken from the old VMA. If the VMA is anonymous and not yet faulted, the page offset is updated to correspond to the new address, this means recalculated as \verb|new_addr >> PAGE_SHIFT|. After that, the \verb|vma_merge()| is called, which tries to merge the not-yet-created VMA with its soon-to-be neighbours. If the merge succeeds, it might happen that the copy in the new location is actually merged with the old VMA, this might happen when the new location is precisely next to the old one. In this case, the pointer to old VMA must be updated. When the merge does not succeed, a duplicate VMA is created using parameters from the old VMA.

\subsection{The move\_page\_tables() function}

\verb|unsigned long move_page_tables(|\break
\indent\indent\indent\indent\indent  \verb|struct vm_area_struct *vma,|\break
\indent\indent\indent\indent\indent  \verb|unsigned long old_addr,|\break
\indent\indent\indent\indent\indent  \verb|struct vm_area_struct *new_vma,|\break
\indent\indent\indent\indent\indent  \verb|unsigned long new_addr,|\break
\indent\indent\indent\indent\indent  \verb|unsigned long len,|\break
\indent\indent\indent\indent\indent  \verb|bool need_rmap_locks,|\break
\indent\indent\indent\indent\indent  \verb|bool update_pgoff)|\break

The \verb|move_page_tables()| function is charged with replicating the page tables. This is done preferably at the PUD level if possible, but e.g. smaller VMAs do not take up whole PUD, in which case the move is done at PMD or even PTE level. The page table move is done regardless whether we merge the VMA with its neighbour or not.


\pagebreak

\section{Other kernel memory mechanisms}

\subsection{Rmap walk}
\label{sec:rmap_walk}

Rmap walk is a mechanism that goes through all mappings of a page and performs an arbitrary action. Because \gls{vma}s can easily be merged or split, pages do not reference their mappings directly. Instead, each anonymous page has a pointer to an \gls{av}, which serves as a bridge between pages and their mappings as described in more detail in \fullref{sec:anon_vma}. The rmap walk basically goes through all the VMAs via the AV and compares the page offset values as can be seen in \figureref{fig:rmap_walk}. It is important to realise that VMA's position in virtual memory and therefore also virtual address can change during \verb|mremap()| call, but VMA's page offset is immutable the same way as the page offset values stored in individual pages. For KSM pages and file mapping pages the implementation is a bit different.

\begin{figure}[H]
  \center
  \includegraphics[width=300px]{../img/rmap_walk.png}
  \caption{Rmap walk identifying the correct VMA using AV and the page offset.}
  \label{fig:rmap_walk}
\end{figure}

\bigbreak

Rmap walk is used during migration to replace the page table entries with migration entries for the time of migration. Another usage is during unmapping of a page to find and replace the page table entries with swap entries.

%rmap\_walk\_anon() in mm/rmap.c

\subsection{The do\_munmap() function}

\verb|int do_munmap(struct mm_struct *mm,|\break
\indent\indent\indent\indent\indent  \verb|unsigned long start,|\break
\indent\indent\indent\indent\indent  \verb|size_t len,|\break
\indent\indent\indent\indent\indent  \verb|struct list_head *uf)|\break

Unmaps a range at the given address with the given length. This unmaps all the VMAs residing there and might also split up to two VMAs, one at the beginning and one at the end of the range, if the range just intersects them.

\subsection{Brk syscall}
Enlarges or shrinks program break, which is the end of program's data segment. This is used to allocate more or less memory for the running program with regard to maximum data size limitation.
\subsubsection{Function do\_brk\_flags()}
This subfunction internally allocates a new mapping, or, if possible, enlarges the old one, creating an opportunity for a merge.

%\subsection{Function find\_vma()}


\subsection{The \_\_split\_vma() function}

\verb|int __split_vma(struct mm_struct *mm,|\break
\indent\indent\indent\indent\indent  \verb|struct vm_area_struct *vma,|\break
\indent\indent\indent\indent\indent  \verb|unsigned long addr, int new_below)|\break

Splits a VMA into two based on the \verb|addr| address using \verb|vma_adjust()|.

%\section{Related work in Linux}
%\gls{todo}
%It seems that in Linux kernel merging 

%\subsection{Windows}
%\gls{todo}
%\subsection{MacOS}
%\gls{todo}

%\subsection{•}

%\begin{figure}
%  \includegraphics[width=\linewidth]{../img/dpp_input.png}
%  \caption{Dpp.cz input form.}
%  \label{fig:dpp_input}
%\end{figure}


%\begin{figure}
%  \includegraphics[width=\linewidth]{../img/dpp_result.png}
%  \caption{Dpp.cz results.}
%  \label{fig:dpp_result}
%\end{figure}
